
import gui.layouts.PreferredSizeGridLayout;
import gui.run.RunButton;
import gui.run.RunMenuItem;
import ip.gui.frames.JClosableFrame;
import xml.adbk.Address;
import xml.adbk.AddressBook;

import javax.swing.*;
import java.awt.*;


/**
 * Created by IntelliJ IDEA.
 * User: Andrew Smith
 * Date: Mar 9, 2004
 * Time: 3:29:12 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyAddressBook {
    static MyAddressBook mine = new MyAddressBook();
    static Address current = new Address();
    static AddressBook thisBook = new AddressBook();
    static Address[] list = new Address[0];
    static JClosableFrame bookFrame = new JClosableFrame("Address Book: Andrew Smith");
    static Container c = bookFrame.getContentPane();

    static JTextArea textOut = new JTextArea(40, 100);
    JTextField firstNameField = new JTextField(10);
    JTextField lastNameField = new JTextField(10);
    JTextField addressField = new JTextField(10);
    JTextField cityField = new JTextField(10);
    JTextField stateField = new JTextField(10);
    JTextField zipCodeField = new JTextField(10);
    JTextField homePhoneField = new JTextField(10);
    JTextField workPhoneField = new JTextField(10);
    JTextField cellPhoneField = new JTextField(10);
    JTextField emailField = new JTextField(10);

    public void setFields(JPanel jp) {
        JPanel fields = new JPanel();

        fields.setLayout(new PreferredSizeGridLayout(0, 2));
        fields.add(new JLabel(""));
        fields.add(new JLabel(""));
        fields.add(new JLabel("First Name:"));
        fields.add(firstNameField);
        fields.add(new JLabel("Last Name:"));
        fields.add(lastNameField);
        fields.add(new JLabel("Address:"));
        fields.add(addressField);
        fields.add(new JLabel("City:"));
        fields.add(cityField);
        fields.add(new JLabel("State:"));
        fields.add(stateField);
        fields.add(new JLabel("Zip Code:"));
        fields.add(zipCodeField);
        fields.add(new JLabel("Home Phone:"));
        fields.add(homePhoneField);
        fields.add(new JLabel("Work Phone:"));
        fields.add(workPhoneField);
        fields.add(new JLabel("Cell Phone:"));
        fields.add(cellPhoneField);
        fields.add(new JLabel("Email:"));
        fields.add(emailField);
        fields.add(new JLabel(""));
        fields.add(new JLabel(""));

        fields.setBorder(BorderFactory.createRaisedBevelBorder());
        jp.add(fields);
    }

    public void setCurrent() {
        current.setFirstName(firstNameField.getText());
        current.setLastName(lastNameField.getText());
        current.setStreet(addressField.getText());
        current.setCity(cityField.getText());
        current.setState(stateField.getText());
        current.setZip(zipCodeField.getText());
        current.setHomePhone(homePhoneField.getText());
        current.setBusinessPhone(workPhoneField.getText());
        //current.setCellPhone(cellPhoneField.getText());
        current.setEmailAddress(emailField.getText());

        firstNameField.setText("");
        lastNameField.setText("");
        addressField.setText("");
        cityField.setText("");
        stateField.setText("");
        zipCodeField.setText("");
        homePhoneField.setText("");
        workPhoneField.setText("");
        cellPhoneField.setText("");
        emailField.setText("");
    }

    public void setBar() {
        JMenuBar jmb = new JMenuBar();
        JMenu file = new JMenu("File");
        file.add(new RunMenuItem("[Open ") {
            public void run() {
                thisBook.open();
                list = thisBook.getAddresses();
            }
        });
        file.add(new RunMenuItem("[Save ") {
            public void run() {
                thisBook.saveAsXml();
            }
        });
        file.add(new RunMenuItem("[Exit") {
            public void run() {
                bookFrame.dispose();
            }
        });
        file.setVisible(true);
        jmb.add(file);
        jmb.add(new RunMenuItem("[Help") {
            public void run() {
                JOptionPane.showMessageDialog(bookFrame,
                        "Help doesn't do anything, put here for Appearance.");

            }
        });
        jmb.setVisible(true);
        bookFrame.setJMenuBar(jmb);
    }

    public void splitPanel() {
        JPanel splitPanel = new JPanel();
        splitPanel.setLayout(new GridLayout(1, 2));
        mine.setFields(splitPanel);
        JPanel output = new JPanel();
        output.setLayout(new BorderLayout());
        output.add(textOut, BorderLayout.CENTER);
        output.setBorder(BorderFactory.createRaisedBevelBorder());
        splitPanel.add(output);
        c.add(splitPanel, BorderLayout.CENTER);

    }

    public void setButtonPanel() {
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());
        buttonPanel.add(new RunButton("Add") {
            public void run() {
                System.out.println("Add Button Clicked");
                mine.setCurrent();
                thisBook.addAddress(current);
                list = thisBook.getAddresses();
            }
        });
        buttonPanel.add(new JLabel("           "));
        buttonPanel.add(new RunButton("Delete") {
            public void run() {
                System.out.println("Delete Button Clicked");

            }
        });
        buttonPanel.add(new JLabel("           "));
        buttonPanel.add(new RunButton("View") {
            public void run() {
                     System.out.println(thisBook.toString());
                    textOut.append(thisBook.toString());

            }
        });
        c.add(buttonPanel, BorderLayout.SOUTH);
    }

    public static void main(String[] args) {

        c.setLayout(
                new BorderLayout());
        mine.setBar();
        mine.splitPanel();
        mine.setButtonPanel();
        bookFrame.setSize(700, 700);
        bookFrame.setVisible(true);
    }
}
