package j2d;

import futils.Futil;
import gui.ClosableJFrame;
import gui.run.RunMenu;
import gui.run.RunMenuItem;

import javax.swing.*;
import java.awt.*;
import java.io.File;
import java.io.FileNotFoundException;

/**
 * DocJava, Inc.
 * http://www.docjava.com
 * Programmer: dlyon
 * Date: Mar 22, 2004
 * Time: 2:22:10 PM
 */
public class HoganizerBad {
    public static void main(String[] args) {
        HoganizerBad hb = new HoganizerBad();
    }
    public HoganizerBad() {
        try {
            img = HoganizerBad.getImage();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private Image img = null;

    public void displayImage(Image img) {
        ClosableJFrame cf = new ClosableJFrame();
        Container c = cf.getContentPane();
        cf.setJMenuBar(getMenuBar());
        cf.setSize(200, 200);
        cf.setVisible(true);
        c.add(getImagePanel(img));
        c.setLayout(new GridLayout(1, 0));
        cf.setSize(200, 200);
        cf.show();
    }

    private JMenu getFileMenu() {
        RunMenu fileMenu = new RunMenu("[File");
        fileMenu.add(new RunMenuItem("[open{ctrl O}") {
            public void run() {
                ImageUtils.getImage();
                //r  this.repaint();
                //this doesnt work
            }
        });
        fileMenu.add(getSaveMenu());
        return fileMenu;
    }

    private JMenuBar getMenuBar() {
        JMenuBar mb = new JMenuBar();
        mb.add(getFileMenu());
        mb.add(getHppMenu());
        return mb;
    }

    private RunMenu getHppMenu() {
        RunMenu hppMenu = new RunMenu("[Hpp");
        hppMenu.add(new RunMenuItem("[negate{ctrl N}") {
            public void run() {
                negate();
            }
        });
        hppMenu.add(new RunMenuItem("[Brighten or Darken{ctrl B}") {
            public void run() {

                System.out.println("Brighten or Darken me baby!");
            }
        });
        hppMenu.add(new RunMenuItem("[Contrast{ctrl C}") {
            public void run() {
                // ImageUtils.getContrastBrightnessAdjustedImage();
                System.out.println("contrast me baby!");
            }
        });
        hppMenu.add(new RunMenuItem("[threshold{ctrl T}") {
            public void run() {
                //         img = ImageUtils.threshold(img, 0);
            }
        });
        hppMenu.add(new RunMenuItem("[Gaussian Filter{ctrl G}") {
            public void run() {
                //  ImageUtils.gaussian();
                System.out.println("Gaussian Filter me baby!");
            }
        });
        hppMenu.add(new RunMenuItem("[Psuedo{ctrl P}") {
            public void run() {
                //    ImageUtils.colorize();
                System.out.println("Psuedo me baby!");
            }
        });
        hppMenu.add(new RunMenuItem("[UNAHE {ctrl U}") {
            public void run() {
                //   ImageUtils.unahe(img);
                System.out.println("UNAHE  me baby!");
            }
        });
        hppMenu.add(new RunMenuItem("[ENAHE {ctrl E}") {
            public void run() {
                //  ImageUtils.enahe();
                System.out.println("ENAHE  me baby!");
            }
        });
        return hppMenu;
    }

    public RunMenu getSaveMenu() {
        RunMenu saveMenu = new RunMenu("[Save");
        saveMenu.add(new RunMenuItem("Save as pp[m{ctrl M}") {
            public void run() {
                 ImageUtils.saveAsPPM(img,
                         futils.Futil.getReadFile("save as .ppm"));
            }
        });
        saveMenu.add(new RunMenuItem("Save as gi[f{ctrl F}") {
            public void run() {
                // ImageUtils.saveAsGif(img,fn);

            }
        });
        saveMenu.add(new RunMenuItem("Save as ppm.g[z{ctrl Z}") {
            public void run() {
                //ImageUtils.saveAsPPMgz(img);
            }
        });
        return saveMenu;
    }

    public static JPanel getImagePanel(final Image img) {
        return new JPanel() {
            public Dimension getPreferredSize() {
                return new Dimension(img.getHeight(this),
                        img.getWidth(this));
            }

            public void paint(Graphics g) {
                Dimension d = getSize();
                int w = d.width;
                int h = d.height;
                g.drawImage(img, 0, 0, w, h, this);
            }
        };
    }

    public void negate() {

    }

    public static Image getImage() throws FileNotFoundException {
        File f = Futil.getReadFile("enter a gif or jpeg");
        return ImageUtils.getImage(f);
    }

}
